--- old/usr/src/lib/libc/amd64/fp/_base_il.c	2014-10-23 17:13:36.907333384 -0400
+++ new/usr/src/lib/libc/amd64/fp/_base_il.c	2014-10-23 17:13:36.912408150 -0400
@@ -39,13 +39,16 @@
  */
 double
 __mul_set(double x, double y, int *pe) {
-	extern void _putmxcsr(), _getmxcsr();
-	int csr;
+	int csr = CSR_DEFAULT;
 	double z;
 
-	_putmxcsr(CSR_DEFAULT);
-	z = x * y;
-	_getmxcsr(&csr);
+	__asm__ __volatile__(
+	    "ldmxcsr	%4\n"
+	    "mulsd	%2,%3\n"
+	    "stmxcsr	%0\n"
+	    : "=m" (csr), "=C" (z)
+	    : "C" (x), "C" (y), "m" (csr));
+
 	if ((csr & 0x3f) == 0) {
 		*pe = 0;
 	} else {
